summaryrefslogtreecommitdiffstats
path: root/usr.sbin/bsdconfig/share/media/ufs.subr
diff options
context:
space:
mode:
authordteske <dteske@FreeBSD.org>2014-01-15 07:49:17 +0000
committerdteske <dteske@FreeBSD.org>2014-01-15 07:49:17 +0000
commita35804263ce5ac47cb5d4819f6b5c9933997c9b0 (patch)
tree5307c06d0753e37d7f6c7040f0ae9896e2701ecd /usr.sbin/bsdconfig/share/media/ufs.subr
parent44abef95373cf49911f4c9bf27ad329cccbd3a05 (diff)
downloadFreeBSD-src-a35804263ce5ac47cb5d4819f6b5c9933997c9b0.zip
FreeBSD-src-a35804263ce5ac47cb5d4819f6b5c9933997c9b0.tar.gz
MFC r259054:
Performance and debugging enhancements: + Remove UNAME_P=$(...) from startup/misc -- already supplied by common.subr + Use f_getvar instead of $(eval echo \$$var) -- f_getvar is sub-shell free + Add `-e' and `-k var' options to f_eval_catch -- increasing use-cases + Use f_eval_catch to display errors on failure -- reducing duplicated code + Use f_eval_catch when we need output from a command -- improving debugging + Optimize f_isinter of strings.subr for performance -- now sub-shell free + Improve error checking on pidfiles -- using f_eval_catch and f_isinteger + Use $var_to_set arg of f_ifconfig_{inet,netmask} -- eliminate sub-shells + Use f_sprintf instead of $(printf ...) -- consolidate sub-shells + Use $var_to_set arg of f_route_get_default -- eliminate sub-shells + Add f_count to replace $(set -- ...;echo $#) -- eliminate sub-shells + Add f_count_ifs to replace $(IFS=x;set -- ...;echo $#) -- no sub-shells + Replace var="$var${var:+ }..." in loops with var="$var ..." with a follow- up var="${var# }" to trim leading whitespace -- optimize loops + Use $var_to_set arg of f_resolv_conf_nameservers -- eliminate sub-shells + Comments for the f_eval_catch function + Remove a duplicate `local ... desc ...' in f_device_get_all of device.subr + Use $var_to_set arg of f_device_capacity -- eliminate sub-shells + Whitespace fixes in f_dialog_init of dialog.subr + Optimize f_inet_atoi of media/tcpip.subr for performance -- sub-shell free + In several cases, send stderr to /dev/null -- clean up runtime execution + Change f_err of common.subr to go to program stderr not terminal stderr, allowing redirection of output from functions that use f_err + Disable debugging when using f_getvar to get variable argument to f_startup_rcconf_map_expand of startup/rcconf.subr + Use f_replace_all instead of $(echo ... | tr | sed) -- performance + Add a $var_to_set option to f_index_{file,menusel_{command,keyword}} of common.subr -- centralize sub-shells
Diffstat (limited to 'usr.sbin/bsdconfig/share/media/ufs.subr')
-rw-r--r--usr.sbin/bsdconfig/share/media/ufs.subr19
1 files changed, 11 insertions, 8 deletions
diff --git a/usr.sbin/bsdconfig/share/media/ufs.subr b/usr.sbin/bsdconfig/share/media/ufs.subr
index 2de29b3..a16b53d 100644
--- a/usr.sbin/bsdconfig/share/media/ufs.subr
+++ b/usr.sbin/bsdconfig/share/media/ufs.subr
@@ -67,7 +67,7 @@ f_media_set_ufs()
local devs ndevs
f_device_find "" $DEVICE_TYPE_UFS devs
- ndevs=$( set -- $devs; echo $# )
+ f_count ndevs $devs
if [ ${ndevs:=0} -eq 0 ]; then
f_variable_get_value $VAR_UFS_PATH \
@@ -117,6 +117,7 @@ f_media_set_ufs()
#
f_media_init_ufs()
{
+ local funcname=f_media_init_ufs
local dev="$1" devname err
device_$dev get devname devname || return $FAILURE
@@ -134,14 +135,13 @@ f_media_init_ufs()
return $FAILURE
fi
- if [ ! -e "$MOUNTPOINT" ] &&
- ! err=$( mkdir -p "$MOUNTPOINT" 2>&1 )
- then
- f_dialog_msgbox "$err"
- return $FAILURE
+ if [ ! -e "$MOUNTPOINT" ]; then
+ f_eval_catch $funcname mkdir 'mkdir -p "%s"' "$MOUNTPOINT" ||
+ return $FAILURE
fi
- if ! err=$( mount "$devname" "$MOUNTPOINT" 2>&1 )
+ if ! f_eval_catch -dk err $funcname mount \
+ 'mount "%s" "%s"' "$devname" "$MOUNTPOINT"
then
err="${err#mount: }"; err="${err#$devname : }"
f_show_msg "$msg_error_mounting_device" \
@@ -175,11 +175,14 @@ f_media_get_ufs()
#
f_media_shutdown_ufs()
{
+ local funcname=f_media_shutdown_ufs
local dev="$1" err
[ "$UFS_MOUNTED" ] || return $FAILURE
- if ! err=$( umount -f "$MOUNTPOINT" 2>&1 ); then
+ if ! f_eval_catch -dk err $funcname umount \
+ 'umount -f "%s"' "$MOUNTPOINT"
+ then
err="${err#umount: }"; err="${err#*: }"
f_show_msg "$msg_could_not_unmount_the_ufs_partition" \
"$MOUNTPOINT" "$err"
OpenPOWER on IntegriCloud